## Packet transmission latency

### Shuttle to A20

#### Measures done with tracing and timestamps (some overhead):

**Without XDP:**

| **Latency measured**                   | **min** | **avg** | **max** |
| -------------------------------------- | ------- | ------- | ------- |
| IRQ -> RX SO_TIMESTAMP                 |   27us  |   31us  |  136us  |
| RX SO_TIMESTAMP -> Userspace timestamp |   85us  |   93us  |  247us  |
| IRQ -> Userspace timestamp             |  112us  |  124us  |  383us  |

**With XDP:**

IRQ -> XDP_REDIRECT : ~30us (more measures needs to be done)

#### Measures done with timestamps (little overhead):

| **Latency measured**                   |        | **Duration** | **Packets number** | **Interval** | **min** | **avg** |  **max** |  
| -------------------------------------- | ------ | ------------ | ------------------ | ------------ | ------- | ------  | ------   |  
| Shuttle timestamp -> A20 timestamp     | XDP    |  2h45        | 50 100 000         | 250us        |   22us  |   24us  |  173us   |
| Shuttle timestamp -> A20 timestamp     | no XDP |              |                    |              |   88us  |   88us  |  300us   |
| RX SO_TIMESTAMP (A20)                  | no XDP |              |                    |              |   67us  |  172us  |  173us   |
| TX SO_TIMESTAMP -> (Shuttle)           | no XDP |              |                    |              |    2us  |   18us  |   20us   |

